﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Drawing.Imaging;
using System.Runtime.InteropServices;

namespace CSharp_WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_SinglePage_GetTextInfo(string lpszPDFFile, ref int lpChars, string lpszOptions);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern void Image2PDFOCR_SinglePage_FreeTextInfo(ref byte lpChars);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_SinglePage_CreatePDF(string lpszInPDFFile, ref byte lpChars, int nCharCount, string lpszOutPDFFile, string lpszOptions);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_PDFCmd(string lpszOptions);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_CreateSearchablePDF(string lpTIFOrPDFFile, string lpOutputFile, string lpOptions);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_GetTextHandle(string lpszTIFOrPDFFile, string lpszOptions);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_GetOCRedPageCount(int hImage2PDFData);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_GetTextInfo(int hImage2PDFData, int nPage, ref int lpOutTextInfo);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_SetTextInfo(int hImage2PDFData, int nPage, ref byte lpInTextInfo, int nCharNum);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern void Image2PDFOCR_FreeTextHandle(int hImage2PDFData);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_CreatePDF(int hImage2PDFData, string lpszOutPDFFile, string lpszOptions);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_CreatePDFInMemory(int hImage2PDFData, string lpszOptions, ref int lpDataBuf, ref int nDataBufLen);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_GetPageCount(string lpszPDFFile);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_GetWordCountOnPage(int hImage2PDFData, int nPage);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_GetWordInfoByIndex(int hImage2PDFData, int nPage, int nWordIndex, ref int X, ref int Y, ref int Width, ref int Height, ref byte lpText);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_SetWordInfoByIndex(int hImage2PDFData, int nPage, int nWordIndex, int X, int Y, int Width, int Height, string lpText);
        [DllImport("i2pocrsdk.dll", CharSet = CharSet.Ansi, SetLastError = true, ExactSpelling = true)]
        private static extern int Image2PDFOCR_ReadPDFFromMemory(int hImage2PDFData, ref byte lpDataBuf, int nDataBufLen);

        public struct TEXTPOSITION
        {
            public int x;
            public int y;
            public int width;
            public int height;
            public byte[] text;
            public void init()
            {
                text = new byte[501];
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string strOptions = null;
            string strInFile = null;
            string strOutFile = null;
            string strLogMsg = null;
            string appPath = Path.GetDirectoryName(Application.ExecutablePath);

            strInFile = appPath + "\\test1.pdf";
            strOutFile = appPath + "\\test1_C#_ocred.pdf";
            strOptions = "-pidpi 300";

            int nPageCount = Image2PDFOCR_GetPageCount(strInFile);
            strLogMsg = "\"" + strInFile + "\" file contains \"" + (nPageCount.ToString()) + "\" pages.";
            MessageBox.Show(strLogMsg);

            int hOCRTextSDK = Image2PDFOCR_GetTextHandle(strInFile, strOptions);
            if (hOCRTextSDK != 0)
            {
                int nOCRedPageCount = Image2PDFOCR_GetOCRedPageCount(hOCRTextSDK);
                for (int page = 0; page <= nOCRedPageCount - 1; page++)
                {
                    int nWordCount = Image2PDFOCR_GetWordCountOnPage(hOCRTextSDK, page);
                    for (int nWordIndex = 0; nWordIndex <= nWordCount - 1; nWordIndex++)
                    {
                        TEXTPOSITION nWord = default(TEXTPOSITION);
                        nWord.init();
                        Image2PDFOCR_GetWordInfoByIndex(hOCRTextSDK, page, nWordIndex, ref nWord.x, ref nWord.y, ref nWord.width, ref nWord.height, ref nWord.text[0]);
                        System.Text.UTF8Encoding enc = new System.Text.UTF8Encoding();
                        string strWord = enc.GetString(nWord.text);
                        Image2PDFOCR_SetWordInfoByIndex(hOCRTextSDK, page, nWordIndex, nWord.x, nWord.y, nWord.width, nWord.height, strWord);
                    }
                }

                int lpDataBuf = 0;
                int nDataBufLen = 0;
                int nRet = Image2PDFOCR_CreatePDFInMemory(hOCRTextSDK, strOptions, ref lpDataBuf, ref nDataBufLen);
                if (nRet == 0 & nDataBufLen > 0)
                {
                    byte[] vecFileData = null;
                    vecFileData = new byte[nDataBufLen + 1];
                    nRet = Image2PDFOCR_ReadPDFFromMemory(hOCRTextSDK, ref vecFileData[0], nDataBufLen);

                    System.IO.FileStream oFileStream = null;
                    oFileStream = new System.IO.FileStream(strOutFile, System.IO.FileMode.Create);
                    oFileStream.Write(vecFileData, 0, vecFileData.Length);
                    oFileStream.Close();
                }
                Image2PDFOCR_FreeTextHandle(hOCRTextSDK);
            }
        }
    }
}
